#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <ti83p.h>
#include <ti83ptokens.h>

unsigned char* Equs[9];

unsigned char CurRow;
unsigned char CurCol;

void ClrScrnFull(void) {
  printf("------>TICALL:ClrScrFull\n");
}

void HomeUp(void) {
  printf("------>TICALL:HomeUp\n");
}

void NewLine(void) {
  printf("\n");
}


void PutC(unsigned char c) {
  printf("%c", c);
}

void PutTokString(unsigned char ta, unsigned char tb) {
  if(ta!=0) {
	printf("%d:%d\n", ta, tb);
  } else {
	printf("%d\n", tb);
  }
}

void OutputExpr(unsigned char num) {
  unsigned int i;
  unsigned char* Equ = Equs[num];
  Equ += 2;
  for(i=0; i<*(unsigned int*)(Equ-2); i++) {
	switch(Equ[i]) {
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case '0':
	  putchar(Equ[i]);
	  break;
	case tAdd:
	  putchar('+');
	  break;
	case tSub:
	  putchar('-');
	  break;
	case tMul:
	  putchar('*');
	  break;
	case tDiv:
	  putchar('/');
	  break;
	case tPower:
	  putchar('^');
	  break;
	case tX:
	  putchar('x');
	  break;
	case tChs:
	  putchar('-');
	  break;
	case tLParen:
	  putchar('(');
	  break;
	case tRParen:
	  putchar(')');
	  break;
	default:
	  putchar(Equ[i]);
	  break;
	}
  }
  putchar('\n');
}

unsigned char IsA2ByteTok(unsigned char t) {
  return 0;
}

void PutS(unsigned char* s) {
  printf("%s", s);
}

void DispInt(unsigned int i) {
  printf("%u", i);
}

unsigned char GetKey(void) {
  unsigned char c = getchar();
  if('0'<= c && c<='9') {
	return c-'0'+Gk0;
  }
  if('a'<= c && c<='z') {
	return c-'a'+GkA;
  }
  return 0;
}

unsigned char* GetEqu(unsigned char num) {
  // adapt size if you change it
  unsigned char p[] = {11, 0, '1', tMul, tX, tPower, '2', tSub, '5', tMul, tX, tAdd, '4'};
  unsigned char* e = (unsigned char*)malloc(40);
  memcpy(e, p, 13);// adapt size!
  Equs[num] = e;
  return e;
}

unsigned char* NewEqu(unsigned char num, unsigned int size) {
  unsigned char* e = (unsigned char*)malloc(size);
  Equs[num] = e;
  return e;
}
